//  -------------------------- Colors Box -------------------------------
//                by Carl Paulson      Cognitive Portals
//                 http://members.tripod.com/~SleepyCP/
//                          cpaulson@home.com
//  ---------------------------------------------------------------------
//
//  Suggested HTML Input:
/*
<APPLET code="ColorBox.class" width=150 height=60>

    <param name=newURL      value="http://members.tripod.com/~SleepyCP/JavaGo/JavaPgms.html">

    <param name=Font        value="Helvetica">
    <param name=Style       value="1">
    <param name=Size        value="28">
    <param name=Message     value="Press Me">
    <param name=Msg1        value="I'm Stuck">

    <param name=DeltaH      value="0">
    <param name=DeltaV      value="8">
    <param name=FG_Color    value="magenta">

    <param name=rColorIn0   value="100">
    <param name=gColorIn0   value="0">
    <param name=bColorIn0   value="0">

    <param name=rColorIn1   value="50">
    <param name=gColorIn1   value="0">
    <param name=bColorIn1   value="70">

    <param name=rColorIn2   value="70">
    <param name=gColorIn2   value="0">
    <param name=bColorIn2   value="30">

    <param name=rColorIn3   value="10">
    <param name=gColorIn3   value="0">
    <param name=bColorIn3   value="100">

    <CENTER><FONT SIZE=3>{If you can read this, your browser 
    dosen`t support Java.}</FONT><BR>
    <FONT FACE="Helvetica" COLOR="#FF0000" SIZE=7>(Color  
    Button Java Applet)</FONT></CENTER><BR>
</APPLET>
*/
//
//  ---------------------------------------------------------------------

import java.applet.Applet;
import java.net.*;
import java.awt.*;
import java.awt.image.*;
import java.util.*;

//  ---------------------------------------------------------------------

public class ColorBox extends Applet implements Runnable {

    private boolean      debug  = true;
    private URL          theURL = null;
    private String       newLoc;
    private int          choice;
    public  Thread       myThread;
    private int          pt1[];
    private int          Height1,    Width1,     fontHeight;
    private Image        newImage;
    private double       rPct_00,    bPct_00,    gPct_00;
    private double       rPct_X0,    bPct_X0,    gPct_X0;
    private double       rPct_0Y,    bPct_0Y,    gPct_0Y;
    private double       rPct_XY,    bPct_XY,    gPct_XY;
    private double       rVarD1,     gVarD1,     bVarD1;
    private double       rVarD2,     gVarD2,     bVarD2;
    private int          rVar,       bVar,       gVar;
    private String       Message,    Msg1;
    private int          Mx1,        Mx2,        My1;
    private double       redX1,      blueX1,     greenX1;
    private double       redY1,      blueY1,     greenY1;
    private FontMetrics  fMetric;
    private int          fHeight,    mLength,    mLen1;
    private int          DEL_V,      DEL_H;
    private Color        ColorFG;


    //  -----------------------------------------------------------------

    public void init() {

//      if (debug) System.out.println("INIT");
        newLoc  = getStringParam("newURL","#");
        System.out.println(newLoc);
        try { theURL = new URL(newLoc); 
        } catch(MalformedURLException e) { 
            System.out.println("Bad URL"); }

        choice  = 1;
        Width1  = getSize().width;
        Height1 = getSize().height;

        double W1 = (double) Width1;
        double H1 = (double) Height1;
 
        pt1     = new int [(Width1-2)*(Height1-2)];

        setFont(getFontParam("FONT","Helvetica","Style",1,"Size",28));
        fMetric = getFontMetrics(getFont());
        fHeight = fMetric.getHeight();

        Message = getStringParam("Message","Help Me");
        mLength = fMetric.stringWidth(Message);
        Msg1    = getStringParam("Msg1","I'm Trapped");
        mLen1   = fMetric.stringWidth(Msg1);

        ColorFG = getColorParam("FG_Color", "Black");
        DEL_V   = getIntParam("DeltaV",0,-100,100);
        DEL_H   = getIntParam("DeltaH",0,-100,100);

        Mx1     = DEL_H + (Width1 - mLength)/2;
        My1     = (Height1 + fHeight)/2 - DEL_V;
        Mx2     = DEL_H + (Width1 - mLen1)/2;

        rPct_00 = (double) getIntParam("rColorIn0", 50,0,100); // default: 50% red
        gPct_00 = (double) getIntParam("gColorIn0",  0,0,100); // min 0; max 100
        bPct_00 = (double) getIntParam("bColorIn0",  0,0,100);

        rPct_X0 = (double) getIntParam("rColorIn1",100,0,100); // default: 100% red
        gPct_X0 = (double) getIntParam("gColorIn1",100,0,100);
        bPct_X0 = (double) getIntParam("bColorIn1",100,0,100);

        rPct_0Y = (double) getIntParam("rColorIn2",  0,0,100);
        gPct_0Y = (double) getIntParam("gColorIn2",100,0,100);
        bPct_0Y = (double) getIntParam("bColorIn2",100,0,100);

        rPct_XY = (double) getIntParam("rColorIn3", 50,0,100);
        gPct_XY = (double) getIntParam("gColorIn3",100,0,100);
        bPct_XY = (double) getIntParam("bColorIn3",100,0,100);

        double redX2   = (rPct_XY - rPct_0Y)/(H1 - 1);
        double redX1   = (rPct_X0 - rPct_00)/(H1 - 1);
        double greenX2 = (gPct_XY - gPct_0Y)/(H1 - 1);
        double greenX1 = (gPct_X0 - gPct_00)/(H1 - 1);
        double blueX2  = (bPct_XY - bPct_0Y)/(H1 - 1);
        double blueX1  = (bPct_X0 - bPct_00)/(H1 - 1);

        double Frac    = 255.0/100.0;

        int i   = 0;
        for (int y = 0; y < (Height1-2); y++) {
            for (int x = 0; x < (Width1-2); x++) {

                rVarD2 = redX2*y   + rPct_0Y;
                gVarD2 = greenX2*y + gPct_0Y;
                bVarD2 = blueX2*y  + bPct_0Y;

                rVarD1 = redX1*y   + rPct_00;
                gVarD1 = greenX1*y + gPct_00;
                bVarD1 = blueX1*y  + bPct_00;

                rVar   = (int)(((rVarD2 - rVarD1)*x/(W1 - 1) + rVarD1)*Frac);
                gVar   = (int)(((gVarD2 - gVarD1)*x/(W1 - 1) + gVarD1)*Frac);
                bVar   = (int)(((bVarD2 - bVarD1)*x/(W1 - 1) + bVarD1)*Frac);

                int alpha = 255;
                pt1[i++]  = (alpha << 24)|(rVar << 16)|(gVar << 8)|bVar;
            }
        }

    }

    // -------------- Override: Prevent Clearing Screen -----------------

    public void update(Graphics g) { 
        paint(g);
    }

    //  -----------------------------------------------------------------

    public void paint( Graphics g ) {
//      if (debug) System.out.println("PAINT");
        if (newImage == null )
            newImage = createImage( new MemoryImageSource(Width1-2, 
                       Height1-2, pt1, 0, Width1-2));

        g.setColor(Color.black);
        g.fillRect(0, 0, Width1, Height1);
        g.drawImage(newImage, 1, 1, this );
        g.setColor(ColorFG);
        if (choice == 1) g.drawString(Message, Mx1, My1);
        else             g.drawString(Msg1,    Mx2, My1);
    }

    // --------------------- implement Runnable -------------------------

    public void run() {	
//      if (debug) System.out.println("RUN");
        while (myThread != null) {
            repaint();
            myThread.suspend();
        }
    }

    // ------------------------------------------------------------------

    public void start() {
//      if (debug) System.out.println("START");
        if (myThread != null) myThread.stop();
        myThread = new Thread(this);
        myThread.start();
    }

    //-------------------------------------------------------------------

    public void stop() {
//      if (debug) System.out.println("STOP");
        myThread = null;
        myThread.stop();
    }

    //-------------------------------------------------------------------

    public boolean handleEvent(Event evt) {
//      if (debug) System.out.println("Event in");
        switch(evt.id) { 
            case Event.MOUSE_DOWN: {
//              if (debug) System.out.println("MOUSE DOWN");
                getAppletContext().showDocument(theURL); 
                return true;

            } case Event.MOUSE_ENTER: {
                choice = -1;
                myThread.resume();
                return true;

            } case Event.MOUSE_EXIT: {
                choice =  1;
                myThread.resume();
                return true;

            } case Event.WINDOW_DESTROY: {
                stop();
                System.exit(0);
                return true;

            } case Event.WINDOW_ICONIFY: {
                myThread.stop();
                return true;

            } case Event.WINDOW_DEICONIFY: {
//              if (debug) System.out.println("DEICONIFY");
                myThread.start();
                return true;

            } case Event.WINDOW_EXPOSE: {
//              if (debug) System.out.println("EXPOSE");
                myThread.start();
                return true;

            } default:
//              if (debug) System.out.println("default");
                return false;
        }
    }

    // ----------------------- getInteger -------------------------------

    public int getIntParam(String i, int def_I, int min_i, int max_i) {
        int i_in;
        try {
            i_in = Integer.parseInt(getParameter(i));
            if ((i_in < min_i)||(i_in > max_i)) throw new Exception();
        } catch (Exception e) {
            System.out.println(i+" invalid; using default value: "+def_I);
            i_in = def_I;
        }	
        return i_in;
    }

    // ------------------------  getBool  -------------------------------

    public boolean getBoolParam(String b, String def_B) {

        String b_str;
        b_str = getParameter(b);
        if (b_str != null) {
            if (b_str.equalsIgnoreCase("false"))      return false;
            else if (b_str.equalsIgnoreCase("true"))  return true;
            else if (b_str.equalsIgnoreCase("0"))     return false;
            else if (b_str.equalsIgnoreCase("1"))     return true;

            else if (def_B != null) {
                if (def_B.equalsIgnoreCase("false"))  return false;
                else if (def_B.equalsIgnoreCase("0")) return false;
                else                                  return true;
            } else                                    return true;
        } else if (def_B != null) {
            if (def_B.equalsIgnoreCase("false"))      return false;
            else if (def_B.equalsIgnoreCase("0"))     return false;
            else                                      return true;
        }   
        return true;
    }

    // -------------------------- getFont  ------------------------------

    public Font getFontParam(String fnt, String def_Fnt, 
            String Style, int def_Style, String Size, int def_Size) {

        String font_Name  = getStringParam(fnt,   def_Fnt);
        int    font_Style = getIntParam   (Style, def_Style, 0, 3);
        int    font_Size  = getIntParam   (Size,  def_Size, 4, 100);

        return (new Font(font_Name, font_Style, font_Size));
    }

    // ------------------------ getColor --------------------------------

    public Color getColorParam(String c, String def_C) {

        Color Color1 = Color.lightGray;      // default color
        if (def_C != null) {
            if      (def_C.equalsIgnoreCase("black"))     Color1 = Color.black;
            else if (def_C.equalsIgnoreCase("blue"))      Color1 = Color.blue;
            else if (def_C.equalsIgnoreCase("cyan"))      Color1 = Color.cyan;
            else if (def_C.equalsIgnoreCase("darkGray"))  Color1 = Color.darkGray;
            else if (def_C.equalsIgnoreCase("gray"))      Color1 = Color.gray;
            else if (def_C.equalsIgnoreCase("green"))     Color1 = Color.green;
            else if (def_C.equalsIgnoreCase("lightGray")) Color1 = Color.lightGray;
            else if (def_C.equalsIgnoreCase("magenta"))   Color1 = Color.magenta;
            else if (def_C.equalsIgnoreCase("orange"))    Color1 = Color.orange;
            else if (def_C.equalsIgnoreCase("pink"))      Color1 = Color.pink;
            else if (def_C.equalsIgnoreCase("red"))       Color1 = Color.red;
            else if (def_C.equalsIgnoreCase("white"))     Color1 = Color.white;
            else if (def_C.equalsIgnoreCase("yellow"))    Color1 = Color.yellow;
        }

        StringTokenizer st;
        String rgbDelim = ":,.";
        String c_str = getParameter(c);
        if (c_str != null) st = new StringTokenizer(c_str, rgbDelim);
        else return Color1;

        if      (c_str.equalsIgnoreCase("black"))     return Color.black;
        else if (c_str.equalsIgnoreCase("blue"))      return Color.blue;
        else if (c_str.equalsIgnoreCase("cyan"))      return Color.cyan;
        else if (c_str.equalsIgnoreCase("darkGray"))  return Color.darkGray;
        else if (c_str.equalsIgnoreCase("gray"))      return Color.gray;
        else if (c_str.equalsIgnoreCase("green"))     return Color.green;
        else if (c_str.equalsIgnoreCase("lightGray")) return Color.lightGray;
        else if (c_str.equalsIgnoreCase("magenta"))   return Color.magenta;
        else if (c_str.equalsIgnoreCase("orange"))    return Color.orange;
        else if (c_str.equalsIgnoreCase("pink"))      return Color.pink;
        else if (c_str.equalsIgnoreCase("red"))       return Color.red;
        else if (c_str.equalsIgnoreCase("white"))     return Color.white;
        else if (c_str.equalsIgnoreCase("yellow"))    return Color.yellow;

        else if (st.countTokens() == 3) {
            Integer r = new Integer(st.nextToken());
            Integer g = new Integer(st.nextToken());
            Integer b = new Integer(st.nextToken());
            Color1    = new Color(r.intValue(), g.intValue(), b.intValue());
            return Color1;
            }
        return Color1;
    }

    // ------------------------ getString -------------------------------

    public String getStringParam(String x, String def_X) {
        String str;
        str = getParameter(x);
        if (str == null) str = def_X;
        return str;
    }

    //-------------------------------------------------------------------

}